Package: groovy.org.codenarc.rule.dry

## [Groovy] Class DuplicateLiteralAstVisitor

- groovy.org.codenarc.rule.dry.DuplicateLiteralAstVisitor

- Abstract superclass for rule AstVisitor classes that detect duplicate literal constants

  Authors:
    Hamlet D'Arcy
    Chris Mair

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `List<String>` | `constants`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DuplicateLiteralAstVisitor (Class constantType, Set ignoreValuesSet)`
    `DuplicateLiteralAstVisitor (List<Class> constantTypes, Set ignoreValuesSet)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `visitArgumentlistExpression(org.codehaus.groovy.ast.expr.ArgumentListExpression expression)`
    `` | `void` | `visitBinaryExpression(org.codehaus.groovy.ast.expr.BinaryExpression expression)`
    `` | `void` | `visitClassEx(org.codehaus.groovy.ast.ClassNode node)`
    `` | `void` | `visitField(org.codehaus.groovy.ast.FieldNode node)`
    `` | `void` | `visitListExpression(org.codehaus.groovy.ast.expr.ListExpression expression)`
    `` | `void` | `visitMapEntryExpression(org.codehaus.groovy.ast.expr.MapEntryExpression expression)`
    `` | `void` | `visitMethodCallExpression(org.codehaus.groovy.ast.expr.MethodCallExpression call)`
    `` | `void` | `visitReturnStatement(org.codehaus.groovy.ast.stmt.ReturnStatement statement)`
    `` | `void` | `visitShortTernaryExpression(org.codehaus.groovy.ast.expr.ElvisOperatorExpression expression)`
    `` | `void` | `visitStaticMethodCallExpression(org.codehaus.groovy.ast.expr.StaticMethodCallExpression call)`

- - ### Property Detail

    - #### List<String> constants

  - ### Constructor Detail

    - #### DuplicateLiteralAstVisitor(Class constantType, Set ignoreValuesSet)

    - #### DuplicateLiteralAstVisitor(List<Class> constantTypes, Set ignoreValuesSet)

  - ### Method Detail

    - #### void visitArgumentlistExpression(org.codehaus.groovy.ast.expr.ArgumentListExpression expression)

    - #### void visitBinaryExpression(org.codehaus.groovy.ast.expr.BinaryExpression expression)

    - #### @Override void visitClassEx(org.codehaus.groovy.ast.ClassNode node)

    - #### void visitField(org.codehaus.groovy.ast.FieldNode node)

    - #### void visitListExpression(org.codehaus.groovy.ast.expr.ListExpression expression)

    - #### void visitMapEntryExpression(org.codehaus.groovy.ast.expr.MapEntryExpression expression)

    - #### void visitMethodCallExpression(org.codehaus.groovy.ast.expr.MethodCallExpression call)

    - #### void visitReturnStatement(org.codehaus.groovy.ast.stmt.ReturnStatement statement)

    - #### void visitShortTernaryExpression(org.codehaus.groovy.ast.expr.ElvisOperatorExpression expression)

    - #### void visitStaticMethodCallExpression(org.codehaus.groovy.ast.expr.StaticMethodCallExpression call)